
math.randomseed(os.time()) for i = 1, 4 do math.random() end
application:setBackgroundColor(0xffffff)


Game = Core.class(Sprite)
function Game:init()
  local WIDTH, HEIGHT = application:getContentWidth(), application:getContentHeight()

  local thingImage = Texture.new("thing.png", false)

  local thingSprites = Sprite.new() -- container sprite to hold our things
  self:addChild(thingSprites)

  local THINGWIDTH, THINGHEIGHT, MAXTHINGS, MAXATTEMPTS = 48, 40, 32, 500

  -- Create a table to store things and insert a thing at a random x, y position
  local things = {}
  table.insert(things, {x = math.random(0, WIDTH - THINGWIDTH), y = math.random(0, THINGHEIGHT), width = THINGWIDTH, height = THINGHEIGHT})

  -- Create a new thing at a random x, y position and return true and add it to the thing table if the new thing does not intersect (overlap) any other existing thing
  local function newThing()

    -- Return true of rectangles intersect (overlap)
    local function rectIntersectsRect(r1, r2)
      if r1.x + r1.width >= r2.x and r1.x <= r2.x + r2.width and r1.y + r1.height >= r2.y and r1.y <= r2.y + r2.height then
        return true
      else
        return false
      end
    end

    local newThing = {x = math.random(0, WIDTH - THINGWIDTH), y = math.random(0, HEIGHT - THINGHEIGHT), width = THINGWIDTH, height = THINGHEIGHT}
    for i = 1, #things do
      local existingThing = things[i]
      if rectIntersectsRect(newThing, existingThing) then
		return false
      end
    end
    table.insert(things, newThing)
    return true
  end

  -- Create our things
  local done, attempts = false, 0
  repeat
    newThing()
	attempts = attempts + 1
	if #things == MAXTHINGS or attempts > MAXATTEMPTS then
      done = true
    end
  until done

 -- compare ISO depth of 2 things
  local function filter(a, b)
    if a.x + a.y < b.x + b.y then -- Magic
      return false
    end
    return true
  end

  table.sort(things, filter) -- Sort things into correct depth order

  -- Add things to display group
  for i = 1, #things do
    local thing = things[i]
    local bitmap = Bitmap.new(thingImage)
	bitmap:setPosition(thing.x, thing.y)
	bitmap:setColorTransform(math.random(), math.random(), math.random())
	thingSprites:addChild(bitmap)
  end

end

stage:addChild(Game.new())
